
#define MD2_MAX_TRIANGLES		4096
#define MD2_MAX_VERTICES		2048
#define MD2_MAX_TEXCOORDS		2048
#define MD2_MAX_FRAMES			512
#define MD2_MAX_SKINS			32
//(MD2_MAX_VERTICES * 4 + 128)
//2048*4+128=8320
#define MD2_MAX_FRAMESIZE		8320



// --------------------------------------------------------------
struct md2_header_t
{
   int magic; 
   int version; 
   int skinWidth; 
   int skinHeight; 
   int frameSize; 
   int numSkins; 
   int numVertices; 
   int numTexCoords; 
   int numTriangles; 
   int numGlCommands; 
   int numFrames; 
   int offsetSkins; 
   int offsetTexCoords; 
   int offsetTriangles; 
   int offsetFrames; 
   int offsetGlCommands; 
   int offsetEnd; 
};

struct  md2_alias_triangleVertex_t
{
   byte vertex[3];
   byte lightNormalIndex;
};

struct md2_triangleVertex_t
{
   float vertex[3];       
   float normal[3];
};

struct md2_triangle_t
{
   short vertexIndices[3];   //short  2 
   short textureIndices[3];
};

struct md2_textureCoordinate_t
{
   short s, t;
};

struct md2_alias_frame_t
{
   float scale[3];
   float translate[3];
   char name[16];
   md2_alias_triangleVertex_t alias_vertices[1];
};

struct md2_frame_t     
{
   char   name[16];   
   DWORD  vertices;      //md2_triangleVertex_t
};


struct md2_glCommandVertex_t
{
   float s, t;
   int vertexIndex;
};


struct skin_t
{
char md2_skin_t[64];     
};


struct md2_model_t
{
	md2_header_t		header;
	DWORD	        	skins;          //skin_t
	DWORD           	texCoords;      //md2_textureCoordinate_t
	DWORD	  		triangles;      //md2_triangle_t
	DWORD		        frames;         //md2_frame_t
	DWORD			glCommandBuffer; //㪠⥫ gl ᯨ᮪
};


struct animation_t
{
	char	nameAnimation[16];
	int		firstFrame;
	int		lastFrame;
};

struct md2_anim_t          
{
	int	 count_anim;
	animation_t anim[MD2_MAX_FRAMES];

};

//  ------------------------------------------------------------------------------------------------------
